import { Component, OnInit, OnDestroy, AfterViewInit } from '@angular/core';
import { FormBuilder, FormGroup, Validators } from '@angular/forms';
import { DatabaseService } from '../../services/database.service';
import { ToasterService } from 'src/app/services/toaster.service';
import { SessionService } from 'src/app/services/session.service';
import { Router } from '@angular/router';
import { Platform } from '@ionic/angular';

@Component({
    selector: 'app-settings',
    templateUrl: './settings.page.html',
    styleUrls: ['./settings.page.scss'],
})
export class SettingsPage implements OnInit, OnDestroy, AfterViewInit {
    /**
     * @var bool flag indicating if form was submitted
     */
    isSubmitted = false;
    /**
     * @var FormGroup form object generated by Angular
     */
    formObj: FormGroup;
    /**
    * @var Subscriber of a back button press event
    */
    backBtnSubscr;
    /**
     * @var Array<string> Ordered list of password hash elements
     */
    algorithmOrder: Array<string> = [
        "hostParts-0",
        "salt",
        "login",
        "salt",
        "hostParts-1"
    ];

    constructor(
        private formBuilder: FormBuilder,
        private database: DatabaseService,
        private toaster: ToasterService,
        private router: Router,
        private session: SessionService,
        private platform: Platform
    ) { }

    async ngOnInit() {
        this.session.login().then(success => {
            if (!success) {
                return this.toaster.error("Login failed");
            }

            this.database.getSettings().then(result => {
                if (!result || !result.salt) {
                    return false;
                }

                this.frmCtrl.salt.setValue(result.salt);
                
                if (result.algorithm) {
                    this.algorithmOrder = result.algorithm;
                }              
            });
        });

        this.formObj = this.formBuilder.group(
            {
                "salt": ["", [Validators.required]]
            }, {}
        );
    }

    ngAfterViewInit() {
        this.backBtnSubscr = this.platform.backButton.subscribe(() => {
            this.backToHomePage();
        });
    }

    ngOnDestroy() {
        if (this.backBtnSubscr) {
            this.backBtnSubscr.unsubscribe();
        }
    }

    doReorder(event: any): void {
        this.algorithmOrder = event.detail.complete(this.algorithmOrder);
    }
    /**
     * Manage form submition
     * 
     * @param values submitted form data
     */
    save(values: any): void {
        this.isSubmitted = true;
        // @NOTE if errors occurred then stop and display them
        if (this.formObj.invalid) {
            return;
        }

        values["algorithm"] = this.algorithmOrder;

        this.database.saveSettings(values).then(() => {
            this.toaster.success("Settings updated");
        }).catch(reason => {
            console.log(reason);
            this.toaster.error("Failed to update settings");
        }).finally(() => {
            this.backToHomePage();
        });
    }
    /**
     * Getter for simplifying controls access
     */
    get frmCtrl() { return this.formObj.controls; }
    /**
     * Translate password algorithm part code into a human redable label
     *
     * @param {string} code
     * @returns {string}
     */
    getAlgorithmPartLabel(code: string): string {
        switch (code) {
            case "hostParts-0":
                return "Domain part I";
            case "hostParts-1":
                return "Domain part II";
            case "salt":
                return "Salt string";
            case "login":
                return "Username";
            default:
                return code;
        }
    }
    /**
     * Get homepage redirect url
     */
    backToHomePage() {
        this.router.navigateByUrl("");
    }
}
